<template>
  <appTable center-header :headers="headers">
    <template #body>
      <tr v-for="(item, index) in bodyList" :key="index">
        <appTableTd v-for="turn in item" :key="turn.id">
          <div class="text-sm text-gray-900">
            {{ tableText(turn).title }}
          </div>
          <div class="text-sm text-gray-500">
            {{ tableText(turn).subtitle }}
          </div>
        </appTableTd>
      </tr>
    </template>
  </appTable>
</template>

<script>
import apiMixin from '../../mixins/api';
export default {
  name: 'assignedShift',
  mixins: [apiMixin],
  computed: {
    headers() {
      return Object.keys(this.turnsLisUnassigned) || [];
    },
    bodyList() {
      const values = Object.values(this.turnsLisUnassigned) || new Array([]);

      const arrayOfLength = [...values].map((e) => e.length);

      let maxCount = Math.max(
        ...(arrayOfLength.length > 0 ? arrayOfLength : [0])
      );

      const col = new Array(values.length).fill('');
      const rows = new Array(maxCount);
      for (let i = 0; i < maxCount; i++) {
        const jLength = this.headers.length;
        rows[i] = [...col];
        for (let j = 0; j < jLength; j++) {
          rows[i][j] = (values[j] && values[j][i]) || '';
        }
      }
      return rows;
    },
  },
  methods: {
    tableText({ turnTemplateId }) {
      const { name, checkIn, checkOut } =
        this.turnsTemplateList.find(({ id }) => id === turnTemplateId) || {};
      const found = name && checkIn && checkOut;
      const title = found ? `${name}` : '';

      const subtitle = found ? `(${checkIn}-${checkOut})` : '';
      return { title, subtitle };
    },
  },
};
</script>

<style></style>
